import 'package:cs_resources/generated/assets.dart';
import 'package:flutter/cupertino.dart';
import 'package:plugin_platform/engine/toast/toast_engine.dart';
import 'package:riverpod_annotation/riverpod_annotation.dart';
import 'package:router/ext/auto_router_extensions.dart';
import 'package:shared/utils/log_utils.dart';

import '../../../router/page/community_page_router.dart';
import '../community_vm.dart';
import '../newsfeed_detail/newsfeed_detail_page.dart';
import 'news_respository.dart';
import 'news_state.dart';

part 'news_vm.g.dart';

@riverpod
class NewsVm extends _$NewsVm {
  late NewsRepository NewsRepositoryInstance;
  NewsState initState() {
    return NewsState(
      list: [
          {
            'id':1,
            'avator': Assets.communityCamera,
            'title': 'William Jefferson',
            'isFollow': false,
            'content': 'She said YES and our lives changed.Thank you all for coming to my propose today.We hope everyone can ……[More]',
            'imageUrls': ['https://img.alicdn.com/tfs/TB1h.o9O4MPMeJjy1XaXXcSsFXa-640-360.jpg','https://img.alicdn.com/tfs/TB1h.o9O4MPMeJjy1XaXXcSsFXa-640-360.jpg','https://img.alicdn.com/tfs/TB1h.o9O4MPMeJjy1XaXXcSsFXa-640-360.jpg'],
            'time': 'June 17,2016 at 7:23 p.m.',
              'isLike': true,
            'likeno': 12
          },
          {
            'id':2,
            'avator': Assets.communityCamera,
            'title': 'William fdsaf的飞洒发生的',
            'isFollow': true,
            'content': 'She said YES and our lives changed.Thank you all for coming to my propose today.We hope everyone can ……[More]',
            'imageUrls': [],
            'time': 'June 17,2016 at 7:23 p.m.',
            'isLike': true,
            'likeno': 12
          },
          {
            'id':3,
            'avator': Assets.communityCamera,
            'title': 'Fsjfkds  dfsk',
            'isFollow': false,
            'content': 'She said YES and our lives changed.Thank you all for coming to my propose today.We hope everyone can ……[More]',
            'imageUrls': [],
            'time': 'June 17,2016 at 7:23 p.m.',
            'isLike': false,
            'likeno': 12
          },
          {
            'id':4,
            'avator': Assets.communityCamera,
            'title': 'Fsjfkds  dfsk',
            'isFollow': false,
            'content': 'She said YES and our lives changed.Thank you all for coming to my propose today.We hope everyone can ……[More]',
            'imageUrls': [],
            'time': 'June 17,2016 at 7:23 p.m.',
            'isLike': false,
            'likeno': 12
          },
          {
            'id':5,
            'avator': Assets.communityCamera,
            'title': 'Fsjfkds  dfsk',
            'isFollow': false,
            'content': 'She said YES and our lives changed.Thank you all for coming to my propose today.We hope everyone can ……[More]',
            'imageUrls': [],
            'time': 'June 17,2016 at 7:23 p.m.',
            'isLike': false,
            'likeno': 12
          },
          {
            'id':6,
            'avator': Assets.communityCamera,
            'title': 'Fsjfkds  dfsk',
            'isFollow': false,
            'content': 'She said YES and our lives changed.Thank you all for coming to my propose today.We hope everyone can ……[More]',
            'imageUrls': [],
            'time': 'June 17,2016 at 7:23 p.m.',
            'isLike': false,
            'likeno': 12
          },
          {
            'id':7,
            'avator': Assets.communityCamera,
            'title': '放大发大水',
            'isFollow': false,
            'content': 'She said YES and our lives changed.Thank you all for coming to my propose today.We hope everyone can ……[More]',
            'imageUrls': [],
            'time': 'June 17,2016 at 7:23 p.m.',
            'isLike': false,
            'likeno': 12
          },
      ]
    );
  }

  @override
  NewsState build(){
    // 引入数据仓库
    NewsRepositoryInstance = ref.read(newsRepositoryProvider);
    final state = initState();
    Log.d("--------------------------build---------------------");

    return state;
  }

   // 设置当前的 tabsRouter 和 pageController
  Future setTabsRouterAndPageController(dynamic tabsRouter, dynamic pageController) async{
    Log.d("setTabsRouterAndPageController---:$tabsRouter");
  }

// 上拉加载
  Future onLoadData() async {
    Log.d("----News_vm-----initListData");
    // await Future.delayed(const Duration(seconds: 2));
    // if(state.list.length >= state.filterCount){
    //   return;
    // }else {
    //   int curPage = state.curPage + 1;
    //   state = state.copyWith(curPage: curPage,);
    //   getListData();
    // }
    // getListData();
  }

  // 获取list 列表数据
  void getListData<T>() async {
    Log.d("加载listData数据---------------start-----");
    try {
      //请求网络
      Map<String, dynamic>  params = {
        "curPage": state.curPage,
        "pageSize": state.pageSize,
      };
      Log.d("请求参数------$params");
      final result = await NewsRepositoryInstance.fetchNewsList(params);
      Log.d("请求完成结果------${result.data}");
      //校验成功失败
      if (result.isSuccess) {
        // state = state.copyWith(serverTime: result.data);
        state = state;
        ToastEngine.show("获取数据成功");
      } else {
        ToastEngine.show(result.errorMsg ?? "Network Load Error");
      }
    } catch (e) {
      ToastEngine.show("Error: $e");
    }
  }


  // 下拉刷新
  Future refreshListData() async {
    Log.d("----property_news_vm-----refreshListData ");
    // await Future.delayed(const Duration(seconds: 2));
    state = state.copyWith(curPage: 1, pageSize: 10);
    // ref.invalidateSelf();
    // ref.invalidate(NewsVmProvider);
    getListData();
  }


  // 点击 like comments  share
  void handlerClickActionBtn(String? actionStr, item){
    final id = item['id'];
    switch (actionStr) {
      case 'like':
        Log.d("点击了 点赞");
        handlerGotoDetail(id);
        break;
      case 'comments':
        Log.d("点击了 评论");
        handlerGotoDetail(id);
        break;
      case 'share':
        Log.d("点击了 分享");
        handlerGotoDetail(id);
        break;
      default:
        Log.d("点击了卡片");
        handlerGotoDetail(id);
        break;
    }
  }
  // 去详情页面
  void handlerGotoDetail(id){
    Log.d("去详情页面");
    appRouter.push(NewsfeedDetailPageRoute(id: id, type:'news'));
  }
}