import 'package:widgets/load_state_layout.dart';

class NewsfeedDetailState {
  //页面 LoadView 状态的展示
  LoadState loadingState;
  String? errorMessage;

  int? curPage;
  int? pageSize = 10;
  int? filterCount = 0;
  Map<String, dynamic> detailInfo;
  List<Map<String, dynamic>> list; // 评论列表

  NewsfeedDetailState({
    this.loadingState = LoadState.State_Loading,
    String? errorMessage,
    this.curPage = 1,
    this.pageSize = 10,
    this.filterCount = 0,
    required this.detailInfo,
    required this.list,
  });

  NewsfeedDetailState copyWith({
    LoadState? loadingState,
    String? errorMessage,
    int? curPage,
    int? pageSize,
    int? filterCount,
    Map<String, dynamic>? detailInfo,
    List<Map<String, dynamic>>? list,
  }) {
    return NewsfeedDetailState(
      loadingState: loadingState ?? this.loadingState,
      errorMessage: errorMessage ?? this.errorMessage,
      curPage: curPage ?? this.curPage,
      pageSize: pageSize ?? this.pageSize,
      filterCount: filterCount ?? this.filterCount,
      detailInfo: detailInfo ?? this.detailInfo,
      list: list ?? this.list,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'loadingState': this.loadingState,
      'errorMessage': this.errorMessage,
      'curPage': this.curPage,
      'pageSize': this.pageSize,
      'filterCount': this.filterCount,
      'detailInfo': this.detailInfo,
      'list': this.list,
    };
  }

  factory NewsfeedDetailState.fromMap(Map<String, dynamic> map) {
    return NewsfeedDetailState(
      loadingState: map['loadingState'] as LoadState,
      errorMessage: map['errorMessage'] as String,
      curPage: map['curPage'] as int,
      pageSize: map['pageSize'] as int,
      filterCount: map['filterCount'] as int,
      detailInfo: map['detailInfo'] as Map<String, dynamic>,
      list: map['list'] as List<Map<String, dynamic>>,
    );
  }
}