class ForrentState {
  int? activeTabIndex =0;
  int? curPage =0;
  int? pageSize =10;
  int? filterCount =0;
  List<String>? tabsList = ['For Sale', 'For Rent'];
  List<Map<String, dynamic>>? list = [];

  ForrentState({
    this.activeTabIndex,
    this.curPage,
    this.pageSize,
    this.filterCount,
    this.tabsList,
    this.list,
  });

  ForrentState copyWith({
    int? activeTabIndex,
    int? curPage,
    int? pageSize,
    int? filterCount,
    List<String>? tabsList,
    List<Map<String, dynamic>>? list,
  }) {
    return ForrentState(
      activeTabIndex: activeTabIndex ?? this.activeTabIndex,
      curPage: curPage ?? this.curPage,
      pageSize: pageSize ?? this.pageSize,
      filterCount: filterCount ?? this.filterCount,
      tabsList: tabsList ?? this.tabsList,
      list: list ?? this.list,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'activeTabIndex': this.activeTabIndex,
      'curPage': this.curPage,
      'pageSize': this.pageSize,
      'filterCount': this.filterCount,
      'tabsList': this.tabsList,
      'list': this.list,
    };
  }

  factory ForrentState.fromMap(Map<String, dynamic> map) {
    return ForrentState(
      activeTabIndex: map['activeTabIndex'] as int,
      curPage: map['curPage'] as int,
      pageSize: map['pageSize'] as int,
      filterCount: map['filterCount'] as int,
      tabsList: map['tabsList'] as List<String>,
      list: map['list'] as List<Map<String, dynamic>>,
    );
  }
}