import 'package:auto_route/auto_route.dart';
import 'package:flutter/material.dart';
import 'package:router/ext/auto_router_extensions.dart';
import 'package:router/path/router_path.dart';

import '../../modules/payment/payment_page.dart';
import '../../modules/payment/info/info_screen.dart';
import '../../modules/payment/manage/manage_screen.dart';
import '../../modules/payment/condo/active/condo_active_screen.dart';
import '../../modules/payment/condo/history/condo_history_screen.dart';
import '../../modules/payment/condo/payment/condo_payment_screen.dart';

part 'payment_page_router.gr.dart';

/*\
 * Payment 模块的路由
 */
@AutoRouterConfig(replaceInRouteName: 'Page|Screen,PageRoute')
class PaymentPageRouter extends _$PaymentPageRouter {
  @override
  List<AutoRoute> get routes => [
        CustomRoute(
          page: PaymentPageRoute.page,
          path: RouterPath.payment,
          transitionsBuilder: applySlideTransition,
          children: [
            AutoRoute(page: InfoPageRoute.page, path: 'info'),
            AutoRoute(page: CondoPaymentPageRoute.page, path: 'payment'),
            AutoRoute(page: CondoActivePageRoute.page, path: 'active'),
            AutoRoute(page: CondoHistoryPageRoute.page, path: 'history'),
            AutoRoute(page: ManagePageRoute.page, path: 'manage'),
          ],
        ),
      ];
}
