import 'package:cs_resources/generated/l10n.dart';
import 'package:cs_resources/theme/app_colors_theme.dart';
import 'package:flutter/material.dart';
import 'package:widgets/ext/ex_widget.dart';
import 'package:widgets/my_load_image.dart';
import 'package:widgets/my_text_view.dart';

class EstateItem extends StatelessWidget {
  final int childIndex;  //组内的索引
  final String item;
  final VoidCallback deleteAction;

  const EstateItem({
    required this.childIndex,
    required this.item,
    required this.deleteAction,
  });

  @override
  Widget build(BuildContext context) {
    return Container(
      width: double.infinity,
      color: context.appColors.whiteBG,
      margin: EdgeInsets.only(top: childIndex == 0 ? 0 : 10),
      padding: const EdgeInsets.only(top: 22.5),
      child: Column(
        children: [
          Row(
            children: [
              MyLoadImage(
                "https://img1.baidu.com/it/u=1656098746,3560654086&fm=253&fmt=auto&app=120&f=JPEG?w=800&h=800",
                width: 65,
                height: 65,
                isCircle: true,
              ).marginOnly(right: 17, left: 15),
              Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  //标题
                  Row(
                    mainAxisSize: MainAxisSize.max,
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: [
                      //姓名
                      MyTextView(
                        "Wu Bing Bing",
                        fontSize: 16,
                        isFontBold: true,
                        textColor: context.appColors.textBlack,
                        maxLines: 2,
                      ).expanded(),

                      //删除
                      MyTextView(
                        S.current.remove,
                        marginRight: 15,
                        fontSize: 16,
                        onClick: deleteAction,
                        isFontMedium: true,
                        textColor: context.appColors.deleteRed,
                      ),
                    ],
                  ),

                  MyTextView(
                    "Owner",
                    fontSize: 15,
                    isFontRegular: true,
                    textColor: context.appColors.textBlack,
                  ),

                  MyTextView(
                    "Block 35 #08-29",
                    fontSize: 15,
                    isFontRegular: true,
                    textColor: context.appColors.textBlack,
                  ),
                ],
              ).expanded(),
            ],
          ),
          const SizedBox(height: 22.5),
          Divider(
            height: 0.5,
            color: context.appColors.backgroundDark,
          ),
          Center(
            child: MyTextView(
              S.current.active,
              paddingTop: 16,
              paddingBottom: 16,
              fontSize: 16,
              isFontMedium: true,
              textColor: context.appColors.textPrimary,
            ),
          )
        ],
      ),
    );
  }
}
